diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/member.c freeciv-patched/common/member.c
--- freeciv-cvs/common/member.c	1970-01-01 01:00:00.000000000 +0100
+++ freeciv-patched/common/member.c	2003-06-30 12:33:10.000000000 +0100
@@ -0,0 +1,216 @@
+/********************************************************************** 
+ Freeciv - Copyright (C) 1996 - A Kjeldberg, L Gregersen, P Unold
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+***********************************************************************/
+
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include <string.h>
+
+#include "member.h"
+#include "support.h"
+
+void read_sound(void *structpt, unsigned long offset, const size_t size,
+                struct section_file *file,
+                const char *sec, const char *membername)
+{
+  char *member = FC_STRUCT_MEMBER_P(char, structpt, offset);
+
+  mystrlcpy(member,
+            secfile_lookup_str_default(file, "-", "%s.%s", sec, membername),
+            size);
+//printf("Read %s -> (sound) %s\n", membername, member);
+}
+
+void read_string(void *structpt, unsigned long offset, const size_t size,
+                 struct section_file *file,
+                 const char *sec, const char *membername)
+{
+  char *member = FC_STRUCT_MEMBER_P(char, structpt, offset);
+
+  mystrlcpy(member,
+            secfile_lookup_str(file, "%s.%s", sec, membername),
+            size);
+//printf("Read %s -> (string) %s\n", membername, member);
+}
+
+void set_string(void *structpt, unsigned long offset, const size_t size,
+                const char *val)
+{
+  char *member = FC_STRUCT_MEMBER_P(char, structpt, offset);
+
+  mystrlcpy(member, val, size);
+}
+
+void get_string(const void *structpt, unsigned long offset,
+    		struct memberdata *data)
+{
+  char *member = FC_STRUCT_MEMBER_P(char, structpt, offset);
+
+  sz_strlcpy(data->str, member);
+}
+
+void binary_string(const char *arg1, const char *arg2, const char op,
+		   struct memberdata *result)
+{
+  if (op == '+') {
+    sz_strlcpy(result->str, arg1);
+    sz_strlcat(result->str, arg2);
+  }
+}
+
+void read_int(void *structpt, unsigned long offset, const size_t size,
+              struct section_file *file,
+              const char *sec, const char *membername)
+{
+  int *member = FC_STRUCT_MEMBER_P(int, structpt, offset);
+
+  *member = secfile_lookup_int(file, "%s.%s", sec, membername);
+//printf("Read %s -> (int) %d\n", membername, *member);
+}
+
+void set_int(void *structpt, unsigned long offset, const size_t size,
+             const char *val)
+{
+  int *member = FC_STRUCT_MEMBER_P(int, structpt, offset);
+
+  *member = atoi(val);
+}
+
+void get_int(const void *structpt, unsigned long offset,
+	     struct memberdata *data)
+{
+  int *member = FC_STRUCT_MEMBER_P(int, structpt, offset);
+
+  my_snprintf(data->str, sizeof(data->str), "%d", *member);
+}
+
+void binary_int(const char *arg1, const char *arg2, const char op,
+		struct memberdata *result)
+{
+  int int1, int2, ires;
+
+  int1 = atoi(arg1);
+  int2 = atoi(arg2);
+  switch(op) {
+  case '+':
+    ires = int1 + int2;
+    break;
+  case '-':
+    ires = int1 - int2;
+    break;
+  case '*':
+    ires = int1 * int2;
+    break;
+  case '/':
+    ires = int1 / int2;
+    break;
+  default:
+    return;
+  }
+  my_snprintf(result->str, sizeof(result->str), "%d", ires);
+}
+
+void read_tech(void *structpt, unsigned long offset, const size_t size,
+               struct section_file *file,
+               const char *sec, const char *membername)
+{
+}
+
+void set_tech(void *structpt, unsigned long offset, const size_t size,
+              const char *val)
+{
+}
+
+void get_tech(const void *structpt, unsigned long offset,
+	      struct memberdata *data)
+{
+}
+
+void copy_members(void *deststructpt, const void *srcstructpt,
+		  const struct members *memberlist)
+{
+  const struct members *pt;
+  struct memberdata data;
+
+  for (pt = memberlist; pt && pt->name; ++pt) {
+    pt->getfunc(srcstructpt, pt->offset, &data);
+    pt->setfunc(deststructpt, pt->offset, pt->size, data.str);
+  }
+}
+
+void read_members(void *structpt, const struct members *memberlist,
+                  struct section_file *file, const char *sec)
+{
+  const struct members *pt;
+
+  for (pt = memberlist; pt && pt->name; ++pt) {
+    if (pt->readfunc) {
+      pt->readfunc(structpt, pt->offset, pt->size, file, sec, pt->name);
+    }
+  }
+}
+
+void read_member(void *structpt, const struct members *memberlist,
+                 const char *membername, struct section_file *file,
+		 const char *sec)
+{
+  const struct members *pt;
+
+  for (pt = memberlist; pt && pt->name; ++pt) {
+    if (strcmp(pt->name, membername) == 0 && pt->readfunc) {
+      pt->readfunc(structpt, pt->offset, pt->size, file, sec, pt->name);
+      return;
+    }
+  }
+}
+
+void set_member(void *structpt, const struct members *memberlist,
+                const char *membername, const char *val)
+{
+  const struct members *pt;
+
+  for (pt = memberlist; pt && pt->name; ++pt) {
+    if (strcmp(pt->name, membername) == 0) {
+      pt->setfunc(structpt, pt->offset, pt->size, val);
+      return;
+    }
+  }
+}
+
+void binary_member(void *structpt, const struct members *memberlist,
+    		   const char *membername, const char *arg1, const char *arg2,
+		   const char op, struct memberdata *result)
+{
+  const struct members *pt;
+
+  for (pt = memberlist; pt && pt->name; ++pt) {
+    if (strcmp(pt->name, membername) == 0 && pt->binfunc) {
+      pt->binfunc(arg1, arg2, op, result);
+      return;
+    }
+  }
+}
+
+void get_member(const void *structpt, const struct members *memberlist,
+                const char *membername, struct memberdata *data)
+{
+  const struct members *pt;
+
+  for (pt = memberlist; pt && pt->name; ++pt) {
+    if (strcmp(pt->name, membername) == 0) {
+      pt->getfunc(structpt, pt->offset, data);
+      return;
+    }
+  }
+}
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/member.h freeciv-patched/common/member.h
--- freeciv-cvs/common/member.h	1970-01-01 01:00:00.000000000 +0100
+++ freeciv-patched/common/member.h	2003-06-30 12:33:10.000000000 +0100
@@ -0,0 +1,98 @@
+/********************************************************************** 
+ Freeciv - Copyright (C) 1996 - A Kjeldberg, L Gregersen, P Unold
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+***********************************************************************/
+#ifndef FC__MEMBER_H
+#define FC__MEMBER_H
+
+/* Functions for accessing structure members by name at runtime */
+
+#include "registry.h"
+
+/* Macros for converting structure members to and from offsets - taken
+ * from GLib.
+ */
+#define FC_STRUCT_OFFSET(struct_type, member) \
+    ((unsigned long) ((char *) &((struct_type *) 0)->member))
+#define FC_STRUCT_MEMBER_P(member_type, struct_p, struct_offset) \
+    ((member_type *) ((char *)(struct_p) + (unsigned long)(struct_offset)))
+#define FC_MEMBER_SIZE(struct_type, member) \
+    (sizeof ((struct_type *) 0)->member)
+ 
+struct memberdata {
+  char str[400];
+};
+
+typedef void (*MemberReadFunc)(void *structpt, unsigned long offset,
+                               const size_t size, struct section_file *file,
+                               const char *sec, const char *membername);
+typedef void (*MemberSetFunc)(void *structpt, unsigned long offset,
+                              const size_t size, const char *val);
+typedef void (*MemberGetFunc)(const void *structpt, unsigned long offset,
+    			      struct memberdata *data);
+typedef void (*MemberBinaryFunc)(const char *arg1, const char *arg2,
+    				 const char op, struct memberdata *result);
+
+struct members {
+  char *name;
+  unsigned long offset;
+  size_t size;
+  MemberReadFunc readfunc;
+  MemberSetFunc setfunc;
+  MemberGetFunc getfunc;
+  MemberBinaryFunc binfunc;
+};
+
+void read_sound(void *structpt, unsigned long offset, const size_t size,
+                struct section_file *file,
+                const char *sec, const char *membername);
+void read_string(void *structpt, unsigned long offset, const size_t size,
+                 struct section_file *file,
+                 const char *sec, const char *membername);
+void set_string(void *structpt, unsigned long offset, const size_t size,
+                const char *val);
+void get_string(const void *structpt, unsigned long offset,
+    		struct memberdata *data);
+void binary_string(const char *arg1, const char *arg2, const char op,
+    		   struct memberdata *result);
+void read_int(void *structpt, unsigned long offset, const size_t size,
+              struct section_file *file,
+              const char *sec, const char *membername);
+void set_int(void *structpt, unsigned long offset, const size_t size,
+             const char *val);
+void get_int(const void *structpt, unsigned long offset,
+    	     struct memberdata *data);
+void binary_int(const char *arg1, const char *arg2, const char op,
+		struct memberdata *result);
+void read_tech(void *structpt, unsigned long offset, const size_t size,
+               struct section_file *file,
+               const char *sec, const char *membername);
+void set_tech(void *structpt, unsigned long offset, const size_t size,
+              const char *val);
+void get_tech(const void *structpt, unsigned long offset,
+    	      struct memberdata *data);
+
+void binary_member(void *structpt, const struct members *memberlist,
+    		   const char *membername, const char *arg1, const char *arg2,
+		   const char op, struct memberdata *result);
+void copy_members(void *deststructpt, const void *srcstructpt,
+		  const struct members *memberlist);
+void read_members(void *structpt, const struct members *memberlist,
+                  struct section_file *file, const char *sec);
+void read_member(void *structpt, const struct members *memberlist,
+                 const char *membername, struct section_file *file,
+		 const char *sec);
+void set_member(void *structpt, const struct members *memberlist,
+                const char *membername, const char *val);
+void get_member(const void *structpt, const struct members *memberlist,
+                const char *membername, struct memberdata *data);
+
+#endif  /* FC__MEMBER_H */
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/modifier.c freeciv-patched/common/modifier.c
--- freeciv-cvs/common/modifier.c	1970-01-01 01:00:00.000000000 +0100
+++ freeciv-patched/common/modifier.c	2003-06-30 12:33:10.000000000 +0100
@@ -0,0 +1,56 @@
+/********************************************************************** 
+ Freeciv - Copyright (C) 1996 - A Kjeldberg, L Gregersen, P Unold
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+***********************************************************************/
+
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include <string.h>
+
+#include "modifier.h"
+#include "shared.h"
+#include "support.h"
+
+/**************************************************************************
+  Convert modifier_type names to int; case insensitive;
+  returns -1 if can't match.
+**************************************************************************/
+int modifier_type_from_str(const char *s,
+    			   struct modifier_type *modifier_types,
+			   int num_mod_types)
+{
+  int i;
+  for (i = 0; i < num_mod_types; ++i) {
+    if (mystrcasecmp(modifier_types[i].name, s) == 0) {
+      return i;
+    }
+  }
+  return -1;
+}
+
+/**************************************************************************
+Does a linear search of modifiers[].name
+Returns -1 if none match.
+**************************************************************************/
+int find_modifier_by_name(const char *s,
+    			  struct modifier *modifiers,
+			  int num_mods)
+{
+  int i;
+  for (i = 0; i < num_mods; ++i) {
+    if (mystrcasecmp(modifiers[i].name, s) == 0) {
+      return i;
+    }
+  }
+  return -1;
+}
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/modifier.h freeciv-patched/common/modifier.h
--- freeciv-cvs/common/modifier.h	1970-01-01 01:00:00.000000000 +0100
+++ freeciv-patched/common/modifier.h	2003-06-30 12:33:10.000000000 +0100
@@ -0,0 +1,48 @@
+/********************************************************************** 
+ Freeciv - Copyright (C) 1996 - A Kjeldberg, L Gregersen, P Unold
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+***********************************************************************/
+#ifndef FC__MODIFIER_H
+#define FC__MODIFIER_H
+
+#include "shared.h"
+
+struct impr_effect;
+
+/* Maximum number of modifier types */
+#define MAX_MODS 16
+
+struct modifier {
+  char name[MAX_LEN_NAME];
+  int type;
+  int tech_requirement;
+  int obsoleted_by;
+  char *action;
+  char *final_action;
+  struct impr_effect *effect; /* list; .type==EFT_LAST terminated */
+};
+  
+struct modifier_type {
+  char name[MAX_LEN_NAME];
+  int id;
+  int tech_requirement;
+  int obsoleted_by;
+  bool must_use;
+};
+
+int modifier_type_from_str(const char *s,
+    			   struct modifier_type *modifier_types,
+			   int num_mod_types);
+int find_modifier_by_name(const char *s,
+    			  struct modifier *modifiers,
+			  int num_mods);
+
+#endif  /* FC__MODIFIER_H */
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/packets.c freeciv-patched/common/packets.c
--- freeciv-cvs/common/packets.c	2003-06-30 12:33:43.000000000 +0100
+++ freeciv-patched/common/packets.c	2003-06-30 12:33:10.000000000 +0100
@@ -38,6 +38,7 @@
 #include "dataio.h"
 #include "events.h"
 #include "fcintl.h"
+#include "government.h"
 #include "log.h"
 #include "mem.h"
 #include "support.h"
@@ -425,6 +426,12 @@
     return receive_packet_ruleset_government_ruler_title(pc);
   case PACKET_RULESET_NATION:
     return receive_packet_ruleset_nation(pc);
+  case PACKET_RULESET_MODIFIER_TYPE:
+    return receive_packet_ruleset_modifier_type(pc);
+  case PACKET_RULESET_MODIFIER:
+    return receive_packet_ruleset_modifier(pc);
+  case PACKET_REQUEST_COMPOUND:
+    return receive_packet_request_compound(pc);
   case PACKET_RULESET_CITY:
     return receive_packet_ruleset_city(pc);
   case PACKET_RULESET_GAME:
@@ -1890,6 +1897,12 @@
   if (has_capability("impr_gen", pc->capability)) {
     dio_put_uint8(&dout, packet->num_unit_flags);
   }
+  if (has_capability("compounds", pc->capability)) {
+    dio_put_uint8(&dout, packet->num_unit_modifier_types);
+    dio_put_uint8(&dout, packet->num_unit_modifiers);
+    dio_put_uint8(&dout, packet->num_gov_modifier_types);
+    dio_put_uint8(&dout, packet->num_gov_modifiers);
+  }
   dio_put_uint8(&dout, packet->num_unit_types);
   dio_put_uint8(&dout, packet->num_impr_types);
   dio_put_uint8(&dout, packet->num_tech_types);
@@ -1941,6 +1954,15 @@
   } else {
     packet->num_unit_flags = F_LAST;
   }
+  if (has_capability("compounds", pc->capability)) {
+    dio_get_uint8(&din, &packet->num_unit_modifier_types);
+    dio_get_uint8(&din, &packet->num_unit_modifiers);
+    dio_get_uint8(&din, &packet->num_gov_modifier_types);
+    dio_get_uint8(&din, &packet->num_gov_modifiers);
+  } else {
+    packet->num_unit_modifier_types = packet->num_unit_modifiers = 0;
+    packet->num_gov_modifier_types  = packet->num_gov_modifiers = 0;
+  }
   dio_get_uint8(&din, &packet->num_unit_types);
   dio_get_uint8(&din, &packet->num_impr_types);
   dio_get_uint8(&din, &packet->num_tech_types);
@@ -2009,6 +2031,13 @@
   if (has_capability("impr_gen", pc->capability)) {
     dio_put_effects(&dout, pc, packet->effect);
   }
+  if (has_capability("compounds", pc->capability)) {
+    int i;
+    dio_put_uint16(&dout, packet->basetype);
+    for (i = 0; i < MAX_MODS; ++i) {
+      dio_put_uint16(&dout, packet->modifiers[i]);
+    }
+  }
 
   /* This must be last, so client can determine length: */
   if(packet->helptext) {
@@ -2076,6 +2105,15 @@
     packet->effect = fc_malloc(sizeof(struct impr_effect));
     packet->effect[0].type = EFT_LAST;
   }
+  if (has_capability("compounds", pc->capability)) {
+    int i;
+    dio_get_uint16(&din, &packet->basetype);
+    for (i = 0; i < MAX_MODS; ++i) {
+      dio_get_uint16(&din, &packet->modifiers[i]);
+    }
+  } else {
+    packet->basetype = U_LAST;
+  }
 
   len = dio_input_remaining(&din);
   if (len > 0) {
@@ -2162,6 +2200,123 @@
 /**************************************************************************
 ...
 **************************************************************************/
+int send_packet_ruleset_modifier_type(struct connection *pc,
+                const struct packet_ruleset_modifier_type *packet)
+{
+  SEND_PACKET_START(PACKET_RULESET_MODIFIER_TYPE);
+
+  dio_put_uint8(&dout, packet->id);
+  dio_put_bool8(&dout, packet->is_gov);
+  dio_put_uint8(&dout, packet->basetype);
+  dio_put_string(&dout, packet->name);
+  dio_put_uint8(&dout, packet->tech_requirement);
+  dio_put_bool8(&dout, packet->must_use);
+
+  SEND_PACKET_END;
+}
+
+/**************************************************************************
+...
+**************************************************************************/
+struct packet_ruleset_modifier_type *
+receive_packet_ruleset_modifier_type(struct connection *pc)
+{
+  RECEIVE_PACKET_START(packet_ruleset_modifier_type, packet);
+
+  dio_get_uint8(&din, &packet->id);
+  dio_get_bool8(&din, &packet->is_gov);
+  dio_get_uint8(&din, &packet->basetype);
+  dio_get_string(&din, packet->name, sizeof(packet->name));
+  dio_get_uint8(&din, &packet->tech_requirement);
+  dio_get_bool8(&din, &packet->must_use);
+
+  RECEIVE_PACKET_END(packet);
+}
+
+/**************************************************************************
+...
+**************************************************************************/
+int send_packet_ruleset_modifier(struct connection *pc,
+                const struct packet_ruleset_modifier *packet)
+{
+  SEND_PACKET_START(PACKET_RULESET_MODIFIER);
+
+  dio_put_uint8(&dout, packet->id);
+  dio_put_bool8(&dout, packet->is_gov);
+  dio_put_string(&dout, packet->name);
+  dio_put_uint8(&dout, packet->type);
+  dio_put_uint8(&dout, packet->tech_requirement);
+  if (has_capability("impr_gen", pc->capability)) {
+    dio_put_effects(&dout, pc, packet->effect);
+  }
+
+  SEND_PACKET_END;
+}
+
+/**************************************************************************
+...
+**************************************************************************/
+struct packet_ruleset_modifier *
+receive_packet_ruleset_modifier(struct connection *pc)
+{
+  RECEIVE_PACKET_START(packet_ruleset_modifier, packet);
+
+  dio_get_uint8(&din, &packet->id);
+  dio_get_bool8(&din, &packet->is_gov);
+  dio_get_string(&din, packet->name, sizeof(packet->name));
+  dio_get_uint8(&din, &packet->type);
+  dio_get_uint8(&din, &packet->tech_requirement);
+  if (has_capability("impr_gen", pc->capability)) {
+    dio_get_effects(&din, pc, &packet->effect);
+  } else {
+    packet->effect = fc_malloc(sizeof(struct impr_effect));
+    packet->effect[0].type = EFT_LAST;
+  }
+
+  RECEIVE_PACKET_END(packet);
+}
+
+/**************************************************************************
+...
+**************************************************************************/
+int send_packet_request_compound(struct connection *pc,
+				 struct packet_request_compound *req)
+{
+  int i;
+  SEND_PACKET_START(PACKET_REQUEST_COMPOUND);
+
+  dio_put_bool8(&dout, req->is_gov);
+  dio_put_string(&dout, req->name);
+  dio_put_uint16(&dout, req->basetype);
+  for (i = 0; i < MAX_MODS; ++i) {
+    dio_put_uint16(&dout, req->modifiers[i]);
+  }
+
+  SEND_PACKET_END;
+}
+
+/**************************************************************************
+...
+**************************************************************************/
+struct packet_request_compound *
+receive_packet_request_compound(struct connection *pc)
+{
+  int i;
+  RECEIVE_PACKET_START(packet_request_compound, packet);
+
+  dio_get_bool8(&din, &packet->is_gov);
+  dio_get_string(&din, packet->name, sizeof(packet->name));
+  dio_get_uint16(&din, &packet->basetype);
+  for (i = 0; i < MAX_MODS; ++i) {
+    dio_get_uint16(&din, &packet->modifiers[i]);
+  }
+
+  RECEIVE_PACKET_END(packet);
+}
+
+/**************************************************************************
+...
+**************************************************************************/
 static void dio_put_effects(struct data_out *dout,
                             struct connection *pc,
                             const struct impr_effect *effect)
@@ -2186,6 +2341,9 @@
     }
     dio_put_uint8(dout, eff->cond_bldg);
     dio_put_uint8(dout, eff->cond_gov);
+    if (has_capability("compounds", pc->capability)) {
+      dio_put_uint8(dout, eff->cond_govmod);
+    }
     dio_put_uint8(dout, eff->cond_adv);
     dio_put_uint8(dout, eff->cond_eff);
     dio_put_uint8(dout, eff->aff_unit);
@@ -2266,6 +2424,9 @@
     }
     dio_get_uint8(din, &(effect[inx].cond_bldg));
     dio_get_uint8(din, &(effect[inx].cond_gov));
+    if (has_capability("compounds", pc->capability)) {
+      dio_get_uint8(din, &(effect[inx].cond_govmod));
+    }
     dio_get_uint8(din, &(effect[inx].cond_adv));
     dio_get_uint8(din, (int *)&(effect[inx].cond_eff));
     dio_get_uint8(din, (int *)&(effect[inx].aff_unit));
@@ -2588,6 +2749,13 @@
   if (has_capability("impr_gen", pc->capability)) {
     dio_put_effects(&dout, pc, packet->effect);
   }
+  if (has_capability("compounds", pc->capability)) {
+    int i;
+    dio_put_uint16(&dout, packet->basetype);
+    for (i = 0; i < MAX_MODS; ++i) {
+      dio_put_uint16(&dout, packet->modifiers[i]);
+    }
+  }
 
   /* This must be last, so client can determine length: */
   if(packet->helptext) {
@@ -2688,6 +2856,15 @@
     packet->effect = fc_malloc(sizeof(struct impr_effect));
     packet->effect[0].type = EFT_LAST;
   }
+  if (has_capability("compounds", pc->capability)) {
+    int i;
+    dio_get_uint16(&din, &packet->basetype);
+    for (i = 0; i < MAX_MODS; ++i) {
+      dio_get_uint16(&din, &packet->modifiers[i]);
+    }
+  } else {
+    packet->basetype = G_MAGIC;
+  }
 
   len = dio_input_remaining(&din);
   if (len > 0) {
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/packets.h freeciv-patched/common/packets.h
--- freeciv-cvs/common/packets.h	2003-06-30 12:33:43.000000000 +0100
+++ freeciv-patched/common/packets.h	2003-06-30 12:33:10.000000000 +0100
@@ -128,6 +128,9 @@
   PACKET_FREEZE_HINT,
   PACKET_THAW_HINT,
   PACKET_PING_INFO,
+  PACKET_RULESET_MODIFIER_TYPE,
+  PACKET_RULESET_MODIFIER,
+  PACKET_REQUEST_COMPOUND,
   PACKET_LAST  /* leave this last */
 };
 
@@ -572,6 +575,10 @@
   int num_unit_types;
   int num_impr_types;
   int num_tech_types;
+  int num_unit_modifier_types;
+  int num_unit_modifiers;
+  int num_gov_modifier_types;
+  int num_gov_modifiers;
   struct {
     int cathedral_plus;
     int cathedral_minus;
@@ -628,6 +635,9 @@
   int paratroopers_mr_sub;
   struct impr_effect *effect;
 
+  int basetype;
+  int modifiers[MAX_MODS];
+
   /* Following is a pointer to malloced memory; on the server, it
      points to putype->helptext, malloced earlier; on the client,
      it is malloced when packet received, and then putype->helptext
@@ -636,6 +646,33 @@
   char *helptext;
 };
 
+struct packet_ruleset_modifier_type {
+  bool is_gov;
+  int id;
+  char name[MAX_LEN_NAME];
+  int basetype;
+  int tech_requirement;
+  bool must_use;
+};
+
+struct packet_ruleset_modifier {
+  bool is_gov;
+  int id;
+  char name[MAX_LEN_NAME];
+  int type;
+  int tech_requirement;
+  char *action;
+  char *final_action;
+  struct impr_effect *effect;
+};
+
+struct packet_request_compound {
+  bool is_gov;
+  int basetype;
+  char name[MAX_LEN_NAME];
+  int modifiers[MAX_MODS];
+};
+
 struct packet_ruleset_tech {
   int id, req[2], root_req;	/* indices for advances[] */
   int flags;
@@ -729,6 +766,9 @@
   int empire_size_mod;
   int empire_size_inc;
   int rapture_size;
+
+  int basetype;
+  int modifiers[MAX_MODS];
       
   int unit_happy_cost_factor;
   int unit_shield_cost_factor;
@@ -1061,6 +1101,19 @@
 struct packet_ruleset_unit *
 receive_packet_ruleset_unit(struct connection *pc);
 
+int send_packet_ruleset_modifier_type(struct connection *pc,
+                const struct packet_ruleset_modifier_type *packet);
+struct packet_ruleset_modifier_type *
+receive_packet_ruleset_modifier_type(struct connection *pc);
+int send_packet_ruleset_modifier(struct connection *pc,
+                const struct packet_ruleset_modifier *packet);
+struct packet_ruleset_modifier *
+receive_packet_ruleset_modifier(struct connection *pc);
+int send_packet_request_compound(struct connection *pc,
+    				 struct packet_request_compound *req);
+struct packet_request_compound *
+receive_packet_request_compound(struct connection *pc);
+
 int send_packet_ruleset_tech(struct connection *pc,
 			     const struct packet_ruleset_tech *packet);
 struct packet_ruleset_tech *
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/packets_lsend.c freeciv-patched/common/packets_lsend.c
--- freeciv-cvs/common/packets_lsend.c	2003-06-07 19:58:26.000000000 +0100
+++ freeciv-patched/common/packets_lsend.c	2003-06-30 12:33:10.000000000 +0100
@@ -239,6 +239,30 @@
   conn_list_iterate_end;
 }
 
+void lsend_packet_ruleset_modifier_type(struct conn_list *dest,
+                const struct packet_ruleset_modifier_type *packet)
+{
+  conn_list_iterate(*dest, pconn)
+    send_packet_ruleset_modifier_type(pconn, packet);
+  conn_list_iterate_end;
+}
+
+void lsend_packet_ruleset_modifier(struct conn_list *dest,
+                const struct packet_ruleset_modifier *packet)
+{
+  conn_list_iterate(*dest, pconn)
+    send_packet_ruleset_modifier(pconn, packet);
+  conn_list_iterate_end;
+}
+
+void lsend_packet_request_compound(struct conn_list *dest,
+    				 struct packet_request_compound *req)
+{
+  conn_list_iterate(*dest, pconn)
+    send_packet_request_compound(pconn, req);
+  conn_list_iterate_end;
+}
+
 void lsend_packet_ruleset_tech(struct conn_list *dest,
 			     const struct packet_ruleset_tech *packet)
 {
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/packets_lsend.h freeciv-patched/common/packets_lsend.h
--- freeciv-cvs/common/packets_lsend.h	2003-06-07 19:58:26.000000000 +0100
+++ freeciv-patched/common/packets_lsend.h	2003-06-30 12:33:10.000000000 +0100
@@ -72,6 +72,12 @@
 				const struct packet_ruleset_control *packet);
 void lsend_packet_ruleset_unit(struct conn_list *dest,
 			     const struct packet_ruleset_unit *packet);
+void lsend_packet_ruleset_modifier_type(struct conn_list *dest,
+                const struct packet_ruleset_modifier_type *packet);
+void lsend_packet_ruleset_modifier(struct conn_list *dest,
+                const struct packet_ruleset_modifier *packet);
+void lsend_packet_request_compound(struct conn_list *dest,
+    				 struct packet_request_compound *req);
 void lsend_packet_ruleset_tech(struct conn_list *dest,
 			     const struct packet_ruleset_tech *packet);
 void lsend_packet_ruleset_building(struct conn_list *dest,
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/shared.c freeciv-patched/common/shared.c
--- freeciv-cvs/common/shared.c	2003-06-07 19:58:26.000000000 +0100
+++ freeciv-patched/common/shared.c	2003-06-30 12:33:10.000000000 +0100
@@ -186,7 +186,7 @@
   Like strcspn but also handles quotes, i.e. *reject chars are 
   ignored if they are inside single or double quotes.
 ***************************************************************/
-static size_t my_strcspn(const char *s, const char *reject)
+size_t my_strcspn(const char *s, const char *reject)
 {
   bool in_single_quotes = FALSE, in_double_quotes = FALSE;
   size_t i, len = strlen(s);
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/shared.h freeciv-patched/common/shared.h
--- freeciv-cvs/common/shared.h	2003-06-26 20:13:14.000000000 +0100
+++ freeciv-patched/common/shared.h	2003-06-30 12:33:10.000000000 +0100
@@ -136,6 +136,7 @@
 
 char *create_centered_string(const char *s);
 
+size_t my_strcspn(const char *s, const char *reject);
 char * get_option(const char *option_name,char **argv,int *i,int argc);
 bool is_option(const char *option_name,char *option);
 int get_tokens(const char *str, char **tokens, size_t num_tokens,
